import os
import re
import string
import sys

import config

basedir = ''

_cache = { }

def _open_read(basename):
	try:
		content = _cache[basename]
	except KeyError:
		global basedir
		path = os.path.join(sys.path[0], config.htmldir,
							basedir, basename + '.html')
		content = open(path).read()
		_cache[basename] = content
	return content

def html_escape(str):
	str = string.replace(str, '&', '&amp;')
	str = string.replace(str, '<', '&lt;')
	str = string.replace(str, '>', '&gt;')
	str = string.replace(str, '"', '&quot;')
	return str

rx_url = re.compile(r'([^\s\"]+://[^\s\"]+)')
def markup_urls(str): return rx_url.sub(r'<a href="\1">\1</a>', str)

rx_addr1 = re.compile(r'<[^>@]+@[^>]+>')
rx_addr2 = re.compile(r'\S+@\S+\.\S+')
def mask_email(str):
	return rx_addr2.sub('####@####.####', str)

functions = { 'string': string,
			  'html': html_escape,
			  'markup_urls': markup_urls,
			  'mask_email': mask_email,
			  }

class EvalDict:
	def __init__(self, dict):
		self.dict = dict
	def __getitem__(self, key):
		try:
			return self.dict[key]
		except KeyError:
			return eval(key, functions, self.dict)

def format(basename, vars=None):
	content = _open_read(basename)
	if vars:
		content = content % EvalDict(vars)
	return sys.stdout.write(content)
